

/*************************** INCLUDE FILES ********************************/
#include "windows.h"
#include "test.h"

HANDLE hWindow;
HANDLE hInst;

POINT apts[5] = {{200,  10},
		 {300, 200},
		 {100, 100},
		 {300, 100},
		 {100, 200}};

HBITMAP hbitmap;
HFONT   hfont;
HRGN    hregion;
HBRUSH  hbrush;
HPEN    hpen;
HDC 	hdcMeta;


HMENU	hmenu;
HMENU	hpopupmenu;
ATOM 	hatom;



char junk1[10];
char GlobalArray[10];
char junk2[10];



/**************************** MAIN PROGRAM ***************************/

long FAR PASCAL TestWindowProc (HWND, unsigned, WORD, LONG);


int PASCAL WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;			     /* current instance	     */
HANDLE hPrevInstance;			     /* previous instance	     */
LPSTR lpCmdLine;			     /* command line		     */
int nCmdShow;				     /* show-window type (open/icon) */

{
    MSG msg;				/* temp buffer to hold message */

    if (hPrevInstance)			 /* Other instances of app running? */
	return (FALSE);

    if (!InitApplication(hInstance)) /* Initialize shared things */
        return (FALSE);		 /* Exits if unable to initialize     */

    /* Perform initializations that apply to a specific instance */

    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);

    while (GetMessage((LPMSG)&msg, NULL, 0, 0))
    {
	TranslateMessage((LPMSG)&msg);	/* translate the message */
	DispatchMessage((LPMSG)&msg);	/* have windows dispatch it */
    }
    CloseTest (hInstance);
    exit(msg.wParam);
}

/****************************************************************************

    FUNCTION: InitApplication(HANDLE)

    PURPOSE: Initializes window data and registers window class

    COMMENTS:

        This function is called at initialization time only if no other 
        instances of the application are running.  This function performs 
        initialization tasks that can be done once for any number of running 
        instances.  

        In this case, we initialize a window class by filling out a data 
        structure of type WNDCLASS and calling the Windows RegisterClass() 
        function.  Since all instances of this application use the same window 
        class, we only need to do this when the first instance is initialized.  


****************************************************************************/

BOOL InitApplication(hInstance)
HANDLE hInstance;			       /* current instance	     */
{
    WNDCLASS  wc;

    /* Fill in window class structure with parameters that describe the       */
    /* main window.                                                           */

    wc.style = CS_DBLCLKS;              /* Class style(s).                    */
    wc.lpfnWndProc = TestWindowProc;       /* Function to retrieve messages for  */
                                        /* windows of this class.             */
    wc.cbClsExtra = 0;                  /* No per-class extra data.           */
    wc.cbWndExtra = 0;                  /* No per-window extra data.          */
    wc.hInstance = hInstance;           /* Application that owns the class.   */
    wc.hIcon = LoadIcon(hInstance, "TestICON");           /* loads icon */
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
    wc.lpszMenuName =  "TestMenu";   /* Name of menu resource in .RC file. */
    wc.lpszClassName = "TestWClass"; /* Name used in call to CreateWindow. */

    /* Register the window class and return success/failure code. */

    return (RegisterClass(&wc));

}


/****************************************************************************

    FUNCTION:  InitInstance(HANDLE, int)

    PURPOSE:  Saves instance handle and creates main window

    COMMENTS:

        This function is called at initialization time for every instance of 
        this application.  This function performs initialization tasks that 
        cannot be shared by multiple instances.  

        In this case, we save the instance handle in a static variable and 
        create and display the main program window.  
        
****************************************************************************/

BOOL InitInstance(hInstance, nCmdShow)
    HANDLE          hInstance;          /* Current instance identifier.       */
    int             nCmdShow;           /* Param for first ShowWindow() call. */
{
    HWND            hWnd;               /* Main window handle.                */

    hInst = hInstance;

    /* Create a main window for this application instance.  */

    hWindow = hWnd = CreateWindow(
        "TestWClass",                	/* See RegisterClass() call.          */
        "Test Application",   		/* Text for window title bar.         */
        ( (WS_OVERLAPPEDWINDOW ) ), 	/* Window style.                      */
        CW_USEDEFAULT,                  /* Default horizontal position.       */
        CW_USEDEFAULT,                  /* Default vertical position.         */
        CW_USEDEFAULT,                  /* Default width.                     */
        CW_USEDEFAULT,                  /* Default height.                    */
        NULL,                           /* Overlapped windows have no parent. */
        NULL,                           /* Use the window class menu.         */
        hInstance,                      /* This instance owns this window.    */
        0L);                    	/* Pointer not needed.                */

    /* If window could not be created, return "failure" */

    if (!hWnd)
        return (FALSE);


    /* Make the window visible; update its client area; and return "success" */

    ShowWindow(hWnd, nCmdShow);  /* Show the window                        */
    UpdateWindow(hWnd);          /* Sends WM_PAINT message                 */
    return (TRUE);               /* Returns the value from PostQuitMessage */

}


/***************************** CLOSING ROUTINE ****************************/
CloseTest (hInstance)
HANDLE hInstance;
{
    return TRUE;
}


/************************ THE TILED WINDOW ROUTINE ****************************/
long FAR PASCAL TestWindowProc (hWnd,
				    message,
				    wParam,
				    lParam)
HWND	    hWnd;
unsigned    message;
WORD	    wParam;
LONG	    lParam;
{
    int i;
    LONG idx;
    FARPROC lpProcAbout;		  /* pointer to the "About" function */
    HDC hDC;


    switch (message)
    {
	case WM_COMMAND:	   /* message: command from application menu */

            switch (wParam)
                {
                case IDM_ABOUT:
		    lpProcAbout = MakeProcInstance(About, hInst);

		    DialogBox(hInst,		 /* current instance	     */
		        "AboutBox",			 /* resource to use	     */
		        hWnd,			 /* parent handle	     */
		        lpProcAbout);		 /* About() instance address */

		    FreeProcInstance(lpProcAbout);

		    break;



                default:
		    if (CauseFault(wParam))
		        break;
		    return (DefWindowProc(hWnd, message, wParam, lParam));

                 }
                 break;


	case WM_PAINT:
	    PaintTestWindow (hWnd);
	    break;

	case WM_DESTROY:
	    PostQuitMessage (0);
	    break;

	default:
	    return (DefWindowProc (hWnd, message, wParam, lParam));
	    break;
    }
    return ((LONG) 0);
}


BOOL CauseFault(WORD wParam)
{
    LOGBRUSH lb;
    HGDIOBJ hgdiobj;
    DWORD color;
    char FileName[80];
    int count;

    switch (wParam)
       {
       // overwrite DS:0
       case IDM_WRITE0:
           OverwriteData(0);
	   break;

       // overwrite DS:4
       case IDM_WRITE4:
           OverwriteData(4);
	   break;

       // overwrite DS:8
       case IDM_WRITE8:
           OverwriteData(8);
	   break;

       // overwrite DS:e
       case IDM_WRITEE:
           OverwriteData(14);
           break;

       // overwrite a malloced area
       case IDM_MALLOC:
           DoMalloc();
           break;

       // overwrite a LocalAlloc area
       case IDM_LOCALALLOC:
           DoLocalAlloc();
           break;

       // overwrite a global array
       case IDM_GLOBALSTR:
           OverwriteGlobal();
           break;

       // overwrite a local array
       case IDM_LOCALSTR:
           OverwriteLocal();
           break;

       // overwrite a global array with lstrcpy
       case IDM_LSTRCPY_GLOBAL:
           lstrcpyGlobal();
           break;

       // overwrite a local array lstrcpy
       case IDM_LSTRCPY_LOCAL:
           lstrcpyLocal();
           break;

       // overwrite a global array with lstrcat
       case IDM_LSTRCAT_GLOBAL:
           lstrcatGlobal();
           break;

       // overwrite a local array lstrcat
       case IDM_LSTRCAT_LOCAL:
           lstrcatLocal();
           break;

       // gp fault
       case IDM_FAULT0d:
           Fault_0d();
           break;

       // stack fault
       case IDM_FAULT0c:
           Fault_0c();
           break;

       // invalid opcode fault
       case IDM_FAULT06:
           Fault_06();
           break;

       // divide by zero fault
       case IDM_FAULT00:
           Fault_00();
           break;


       // LocalAlloc memory leakage
       case IDM_LLEAK256:
	   LocalLeak(256);
           break;
       case IDM_LLEAK1K:
	   LocalLeak(1024);
           break;
       case IDM_LLEAK4K:
	   LocalLeak(4096);
           break;
       case IDM_LLEAK16K:
	   LocalLeak(16384);
           break;

       // GlobalAlloc memory leakage
       case IDM_GLEAK1K:
	   GlobalLeak(1024L);
           break;
       case IDM_GLEAK4K:
	   GlobalLeak(4096L);
           break;
       case IDM_GLEAK16K:
	   GlobalLeak(16384L);
           break;
       case IDM_GLEAK64K:
	   GlobalLeak(65536L);
           break;

       // gdi.exe resource leakage
       case IDM_BITMAP:
           hbitmap = CreateBitmap(80, 80, 1, 8, NULL);
	   break;
       case IDM_FONT:
           hfont = CreateFont(20, 32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL);
	   break;
       case IDM_REGION:
           hregion = CreatePolygonRgn(apts, sizeof(apts)/sizeof(POINT),
	   			      ALTERNATE);
	   break;
       case IDM_BRUSH:
	   lb.lbStyle = BS_HATCHED;
	   lb.lbColor = RGB(255, 0, 0);
	   lb.lbHatch = HS_BDIAGONAL;
	   hbrush = CreateBrushIndirect(&lb);
	   break;
       case IDM_PEN:
	   hpen = CreatePen(PS_SOLID, 6, RGB(255, 0, 255));
	   break;
       case IDM_METAFILE:
	   hdcMeta = CreateMetaFile(NULL);
           break;

       // user.exe resource leakage
       case IDM_MENU:
	   hmenu = CreateMenu();
	   AppendMenu(hmenu, MF_ENABLED | MF_STRING, 900,
	       "&New Menu Item");
           break;
       case IDM_POPUPMENU:
	   hpopupmenu = CreatePopupMenu();
	   AppendMenu(hpopupmenu, MF_ENABLED | MF_STRING, 800,
	       "&New Popup Menu Item");
           break;
       case IDM_ATOM:
	   hatom = GlobalAddAtom("This is a new global atom");
           break;
       case IDM_PROP:
	   SetProp(hWindow, "New Window Property", IDM_PROP);
           break;
       case IDM_ICON:
	   LoadIcon(hInst, "NewICON");
           break;

       // bad parameters
       case IDM_STOCKOBJ:
	   hgdiobj = GetStockObject(0x4567);
           break;
       case IDM_TEXTCOLOR:
	   color = GetTextColor(0xabcd);
           break;
       case IDM_GETMODULE:
           count = 0;
	   GetModuleFileName(hInst, FileName, count);
           break;
       case IDM_FREELIB:
	   FreeLibrary(0xeeee);
           break;
       case IDM_DELETEMENU:
	   DeleteMenu(0xff00, 0, MF_BYPOSITION);
           break;
       case IDM_CLIENTRECT:
	   GetClientRect(hWindow, (RECT FAR *) 0x1234567L);
           break;

       // stack usage routines
       case IDM_STACK1000:
	   UseStack(1000);
           break;
       case IDM_STACK500:	
	   UseStack(500);
           break;
       case IDM_STACK100:	
	   UseStack(100);
           break;
       case IDM_STACKALL:	
	   UseStack(0);
           break;

       // bad frees
       case IDM_FREE1:
           LocalFreeDouble();
           break;
       case IDM_FREE2:
           GlobalFreeDouble();
           break;    
       case IDM_FREE3:
           LocalFreeBad();
           break;
       case IDM_FREE4:
           GlobalFreeBad();
           break;

       default:
           return (FALSE);
       }
       return (TRUE);
}

// double free a LocalAlloc'ed block
LocalFreeDouble()
{
    char *ptr;

    ptr = (char *) LocalAlloc (LMEM_FIXED | LMEM_ZEROINIT, 100);

    LocalFree((HANDLE) ptr);
    LocalFree((HANDLE) ptr);
}


// LocalFree an invalid handle
LocalFreeBad()
{
    LocalFree(0x10);
}


// GlobalFree an invalid handle
GlobalFreeBad()
{
    GlobalFree(0x10);
}


// double free a GlobalAlloc'ed block
GlobalFreeDouble()
{
    HANDLE hglobal;

    hglobal = GlobalAlloc(GHND, 512);
    GlobalFree(hglobal);
    GlobalFree(hglobal);
}


OverwriteData(char *ptr)
{
    char onechar;

    onechar = *ptr;
    *ptr = onechar;
}


OverwriteLocal()
{
    char xxx[2];
    char LocalArray[50];
    char yyy[2];

    memset(LocalArray, 0x44, 51);
}

// overwrite a global array
OverwriteGlobal()
{
    memset(GlobalArray, 0x44, 11);
}


// overwrite a local array with lstrcpy
lstrcpyLocal()
{
    char xxx[2];
    char LocalArray[10];
    char yyy[2];

    lstrcpy(LocalArray, "0123456789");
}

// overwrite a global array with lstrcpy
lstrcpyGlobal()
{
    lstrcpy(GlobalArray, "0123456789");
}


// overwrite a local array with lstrcat
lstrcatLocal()
{
    char xxx[10];
    char LocalArray[10];
    char yyy[10];

    lstrcpy(LocalArray, "01234");
    lstrcat(LocalArray, "01234");
}

// overwrite a global array with lstrcat
lstrcatGlobal()
{
    lstrcpy(GlobalArray, "01234");
    lstrcat(GlobalArray, "01234");
}


// overwrite a malloc'ed area with memset
DoMalloc()
{
    char *ptr;

    ptr = (char *) malloc(100);
    memset(ptr, 0, 102);
    free(ptr);
}


// overwrite a LocalAlloc'ed area
DoLocalAlloc()
{
    char *ptr;
    int i;

    ptr = (char *) LocalAlloc (LMEM_FIXED | LMEM_ZEROINIT, 100);
    for (i=0; i<=100; ++i)
        ptr[i] = 0x77;

    LocalFree((HANDLE) ptr);
}


// do a localalloc without ever freeing
LocalLeak(WORD leak_size)
{
    HANDLE hlocal;

    hlocal = LocalAlloc (LMEM_FIXED | LMEM_ZEROINIT, leak_size);
}


// do a globalalloc without ever freeing
GlobalLeak(LONG leak_size)
{
    HANDLE hglobal;

    hglobal = GlobalAlloc(GHND, leak_size);
}


/***************************** THE PAINT ROUTINE ****************************/
PaintTestWindow (hWnd)
HWND	    hWnd;
{
    PAINTSTRUCT ps;

    BeginPaint (hWnd, (LPPAINTSTRUCT) &ps);

    ValidateRect(hWnd, (LPRECT)NULL);
    EndPaint(hWnd, (LPPAINTSTRUCT) &ps);

    return TRUE;
}

/****************************************************************************

    FUNCTION: About(HWND, unsigned, WORD, LONG)

    PURPOSE:  Processes messages for "About" dialog box

    MESSAGES:

	WM_INITDIALOG - initialize dialog box
	WM_COMMAND    - Input received

    COMMENTS:

	No initialization is needed for this particular dialog box, but TRUE
	must be returned to Windows.

	Wait for user to click on "Ok" button, then close the dialog box.

****************************************************************************/

BOOL FAR PASCAL About(hDlg, message, wParam, lParam)
HWND hDlg;                                /* window handle of the dialog box */
unsigned message;                         /* type of message                 */
WORD wParam;                              /* message-specific information    */
LONG lParam;
{
    switch (message) {
	case WM_INITDIALOG:		   /* message: initialize dialog box */
	    return (TRUE);

	case WM_COMMAND:		      /* message: received a command */
	    if (wParam == IDOK                /* "OK" box selected?	     */
                || wParam == IDCANCEL) {      /* System menu close command? */
//		memset(GlobalArray, 0x44, 11);
		EndDialog(hDlg, TRUE);	      /* Exits the dialog box	     */
		return (TRUE);
	    }
	    break;
    }
    return (FALSE);			      /* Didn't process a message    */
}


